<?php

namespace Teknisa\FIN\Modules\ContaPagar\Factory;

use Teknisa\Model\Financeiro\Entities\Ajbolrec;
use Teknisa\Model\Financeiro\Entities\Ajbolpag;
use Teknisa\Model\Financeiro\Entities\Ajctpagar;
use Teknisa\Model\Financeiro\Entities\Ajctreceber;
use Teknisa\Model\Financeiro\Entities\Compensacontpag;
use Teknisa\Model\Financeiro\Entities\Itemcompcontpag;
use Teknisa\Model\Financeiro\Entities\Movbancario;
use Teknisa\Model\Financeiro\Entities\Movdebbanc;
use Teknisa\Model\Financeiro\Entities\Movcredbanc;
use Teknisa\Model\Financeiro\Entities\Contapagar;
use Teknisa\Model\Financeiro\Entities\Contareceber;
use Teknisa\Model\Financeiro\Entities\Boletpagar;
use Teknisa\Model\Financeiro\Entities\Boletreceber;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Model\Financeiro\Entities\Baixarecebida;
use Teknisa\Model\Financeiro\Entities\Baixapaga;
use Teknisa\Model\Fiscal\Entities\Notafiscal;
use Teknisa\Model\Geral\Entities\Fornecedor;
use Teknisa\Model\Geral\Entities\Paramgeral;
use Teknisa\Model\Financeiro\Entities\Empleasing;
use Teknisa\Model\Financeiro\Entities\Ccorforn;
use Teknisa\Model\Financeiro\Entities\Rattpctp;
use Teknisa\Model\Financeiro\Entities\Ratctpagar;
use Teknisa\Model\Contabilidade\Entities\Lanccont;
use Teknisa\Model\Contabilidade\Entities\Contopectbl;
use Teknisa\Model\Financeiro\Entities\GeralPag;

class Pag16000EmprestimoLeasingPagarFactory
{

    protected $entityManager;

    public function __construct($entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function insereContaPagar($rowConta){
        /** @var Contapagar $contapagar */
        $contapagar = new Contapagar();
        $contapagar->setNrorg($rowConta['NRORG']);
        $contapagar->setCdfilial($rowConta['CDFILIAL']);
        $contapagar->setNrlanctonf($rowConta['NRLANCTONF']);
        $contapagar->setNrseqvenpag($rowConta['NRSEQVENPAG']);
        $contapagar->setNrparcelapag($rowConta['NRPARCELAPAG']);
        $contapagar->setDtorigvenpag($rowConta['DTORIGVENPAG']);
        $contapagar->SetVratuapag($rowConta['VRATUAPAG']);
        $contapagar->SetCdtpctpagar($rowConta['CDTPCTPAGAR']);
        $contapagar->setDtatuavenpag($rowConta['DTATUAVENPAG']);
        $contapagar->setVrorigpag($rowConta['VRORIGPAG']);
        $contapagar->setCdfilibpag($rowConta['CDFILIBPAG']);
        $contapagar->setNrlanbolpag($rowConta['NRLANBOLPAG']);
        $contapagar->setIdstatpag($rowConta['IDSTATPAG']);
        $contapagar->setQtdiasvenpag($rowConta['QTDIASVENPAG']);
        $contapagar->setDscontapag($rowConta['DSCONTAPAG']);
        $contapagar->setCdclassfina($rowConta['CDCLASSFINA']);
        $contapagar->setCdempresa($rowConta['CDEMPRESA']);
        $contapagar->setDtmovfluxo($rowConta['DTMOVFLUXO']);
        $contapagar->setIdmovfluxo($rowConta['IDMOVFLUXO']);
        $contapagar->setCdfimovflpag($rowConta['CDFIMOVFLPAG']);
        $contapagar->setNrsequencialemp($rowConta['NRSEQUENCIALEMP']);
        $contapagar->setDtinclusao(DateUtil::getDataAtual());

        return $contapagar;
    }


    /*public function insereContaPagar(
        $nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag, $dtorigvenpag,
        $vratuapag, $cdtpctpagar, $dtatuavenpag, $vrorigpag, $cdfilibpag, $nrlanbolpag,
        $idstatpag, $qtdiasvenpag, $cdclassfina, $cdempresa, $dtmovfluxo,
        $idmovfluxo, $cdfimovflpag, $dscontapag, $cdmotiparc, $nrsequencialemp
    ){

        $contapagar = new Contapagar();
        $contapagar->setNrorg($nrorg);
        $contapagar->setCdfilial($cdfilial);
        $contapagar->setNrlanctonf($nrlanctonf);
        $contapagar->setNrseqvenpag($nrseqvenpag);
        $contapagar->setNrparcelapag($nrparcelapag);
        $contapagar->setDtorigvenpag($dtorigvenpag);
        $contapagar->setVratuapag($vratuapag);
        $contapagar->setCdtpctpagar($cdtpctpagar);
        $contapagar->setDtatuavenpag($dtatuavenpag);
        $contapagar->setVrorigpag($vrorigpag);
        $contapagar->setCdfilibpag($cdfilibpag);
        $contapagar->setNrlanbolpag($nrlanbolpag);
        $contapagar->setIdstatpag($idstatpag);
        $contapagar->setQtdiasvenpag($qtdiasvenpag);
        $contapagar->setDscontapag($dscontapag);
        $contapagar->setCdclassfina($cdclassfina);
        $contapagar->setCdempresa($cdempresa);
        $contapagar->setDtmovfluxo($dtmovfluxo);
        $contapagar->setIdmovfluxo($idmovfluxo);
        $contapagar->setCdfimovflpag($cdfimovflpag);
        $contapagar->setNrsequencialemp($nrsequencialemp);
        $contapagar->setDtinclusao(DateUtil::getDataAtual());

        return $contapagar;
    }*/

    public function insereMovbancario($rowMovimento)
    {
        $movbancario = new Movbancario();
        $movbancario->setCdreducont($rowMovimento['CDREDUCONT']);
        $movbancario->setNrmovbanc($rowMovimento['NRMOVBANC']);
        $movbancario->setDtmovbanc($rowMovimento['DTMOVBANC']);
        $movbancario->setDtinclusao(DateUtil::getDataAtual());
        $movbancario->setIdmovbanc($rowMovimento['DEBCRED']);
        $movbancario->setNrdocmbanc($rowMovimento['NRDOCMBANC']);
        $movbancario->setDshismbanc($rowMovimento['DSHISMBANC']);
        $movbancario->setVrmovbanc($rowMovimento['VRMOVBANC']);
        $movbancario->setIdorigmbanc($rowMovimento['DEBCRED']);
        $movbancario->setIdstconext($rowMovimento['IDSTCONEXT']);
        $movbancario->setNrorg($rowMovimento['NRORG']);
        return $movbancario;
    }

    public function insereMovcredbanc($rowMovcredbanc)
    {
        $movcredbanc = new Movcredbanc();
        $movcredbanc->setCdreducont($rowMovcredbanc['CDREDUCONT']);
        $movcredbanc->setNrmovicred($rowMovcredbanc['NRMOVICRED']);
        $movcredbanc->setCdclassfina($rowMovcredbanc['CDCLASSFINA']);
        $movcredbanc->setCdempresa($rowMovcredbanc['CDEMPRESA']);
        $movcredbanc->setCdfilial($rowMovcredbanc['CDFILIAL']);
        $movcredbanc->setDtmovfluxo($rowMovcredbanc['DTMOVBANC']);
        $movcredbanc->setDtinclusao(DateUtil::getDataAtual());
        $movcredbanc->setIdmovfluxo($rowMovcredbanc['IDMOVFLUXO']);
        $movcredbanc->setNrmovbanc($rowMovcredbanc['NRMOVBANC']);
        $movcredbanc->setCdtpcredbanc($rowMovcredbanc['CDTPCREDBANC']);
        $movcredbanc->setDtmovicred($rowMovcredbanc['DTMOVBANC']);
        $movcredbanc->setDsmovicred($rowMovcredbanc['DSMOVICRED']);
        $movcredbanc->setVrmovicred($rowMovcredbanc['VRMOVICRED']);
        $movcredbanc->setCdectbmcred($rowMovcredbanc['CDEMPRESA']);
        $movcredbanc->setCdfililancre($rowMovcredbanc['CDFILIAL']);
        $movcredbanc->setNrsequencialemp($rowMovcredbanc['NRSEQUENCIALEMP']);
        $movcredbanc->setNrorg($rowMovcredbanc['NRORG']);
        $movcredbanc->setCdforneced($rowMovcredbanc['CDFORNECED']);
        return $movcredbanc;
    }

    public function insereMovdebbanc($rowMovcredbanc)
    {
        try {
            $movdebbanc = new Movdebbanc();
            $movdebbanc->setCdreducont($rowMovcredbanc['CDREDUCONT']);
            $movdebbanc->setNrmovidebi($rowMovcredbanc['NRMOVIDEB']);
            $movdebbanc->setCdclassfina($rowMovcredbanc['CDCLASSFINA']);
            $movdebbanc->setCdempresa($rowMovcredbanc['CDEMPRESA']);
            $movdebbanc->setCdfilial($rowMovcredbanc['CDFILIAL']);
            $movdebbanc->setDtmovfluxo($rowMovcredbanc['DTMOVBANC']);
            $movdebbanc->setDtinclusao(DateUtil::getDataAtual());
            $movdebbanc->setIdmovfluxo($rowMovcredbanc['IDMOVFLUXO']);
            $movdebbanc->setNrmovbanc($rowMovcredbanc['NRMOVBANC']);
            $movdebbanc->setCdtpdebibanc($rowMovcredbanc['CDTPDEBIBANC']);
            $movdebbanc->setDtmovidebi($rowMovcredbanc['DTMOVBANC']);
            $movdebbanc->setDsmovidebi($rowMovcredbanc['DSMOVIDEBI']);
            $movdebbanc->setVrmovidebi($rowMovcredbanc['VRMOVIDEBI']);
            $movdebbanc->setCdectbmdeb($rowMovcredbanc['CDEMPRESA']);
            $movdebbanc->setCdfililandeb($rowMovcredbanc['CDFILIAL']);
            $movdebbanc->setNrsequencialemp($rowMovcredbanc['NRSEQUENCIALEMP']);
            $movdebbanc->setNrorg($rowMovcredbanc['NRORG']);
            $movdebbanc->setCdforneced($rowMovcredbanc['CDFORNECED']);
            return $movdebbanc;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /*public function insereMovdebbanc($cdreducont, $nrmovideb, $cdclassfina, $cdempresa, $dtmovbanc, $idmovfluxo, $nrmovbanc, $cdtpdebbanc,
                                      $dtmovbanc, $descricao, $vrmovideb, $nrorg, $nrsequencialemp, $nrlanccont, $cdfilial, $cdforneced)
    {
        try {
            $movdebbanc = new Movdebbanc();
            $movdebbanc->setCdreducont($cdreducont);
            $movdebbanc->setNrmovidebi($nrmovideb);
            $movdebbanc->setCdclassfina($cdclassfina);
            $movdebbanc->setCdempresa($cdempresa);
            $movdebbanc->setCdfilial($cdfilial);
            $movdebbanc->setDtmovfluxo($dtmovbanc);
            $movdebbanc->setDtinclusao(DateUtil::getDataAtual());
            $movdebbanc->setIdmovfluxo($idmovfluxo);
            $movdebbanc->setNrmovbanc($nrmovbanc);
            $movdebbanc->setCdtpdebibanc($cdtpdebbanc);
            $movdebbanc->setDtmovidebi($dtmovbanc);
            $movdebbanc->setDsmovidebi($descricao);
            $movdebbanc->setVrmovidebi($vrmovideb);
            $movdebbanc->setCdectbmdeb($cdempresa);
            $movdebbanc->setCdfililandeb($cdfilial);
            $movdebbanc->setNrsequencialemp($nrsequencialemp);
            $movdebbanc->setNrorg($nrorg);
            $movdebbanc->setCdforneced($cdforneced);
            return $movdebbanc;
        } catch (\Exception $e) {
            throw $e;
        }
    }*/

    public function insereNotaFiscalPagar($rowNotaFiscal){

        /** @var Notafiscal $notafiscal */
        $notafiscal = new Notafiscal();
        $notafiscal->setNrorg($rowNotaFiscal['NRORG']);
        $notafiscal->setCdfilial($rowNotaFiscal['CDFILIPROC']);
        $notafiscal->setCdfilirece($rowNotaFiscal['CDFILIORIG']);
        $notafiscal->setNrlanctonf($rowNotaFiscal['NRLANCTONF']);
        $notafiscal->setCdempresa($rowNotaFiscal['CDEMPRESA']);
        $notafiscal->setCdinscesta($rowNotaFiscal['CDINSCESTA']);
        $notafiscal->setCdinscmuni($rowNotaFiscal['CDINSCMUNI']);
        $notafiscal->setIdtpijurnf($rowNotaFiscal['IDTPIJURNF']);
        $notafiscal->setNrinsjurnf($rowNotaFiscal['NRINSJURNF']);
        $notafiscal->setCdforneced($rowNotaFiscal['CDFORNECED']);
        $notafiscal->setIddocfinanc('S');
        $notafiscal->setIddocfiscal('N');
        $notafiscal->setIdbloqueado('S');
        $notafiscal->setIdentrsaidop('E');
        $notafiscal->setIddoccontab('S');
        $notafiscal->setIdsistema('PAG');
        $notafiscal->setVrprodutos($rowNotaFiscal['VRNOTAFISC']);
        $notafiscal->setVrnotafisc($rowNotaFiscal['VRNOTAFISC']);
        $notafiscal->setNrnotafisc($rowNotaFiscal['NRNOTAFISC']);
        $notafiscal->setDtemissao($rowNotaFiscal['DTCONTRATOEMP']);
        $notafiscal->setDtentrsaid($rowNotaFiscal['DTCONTRATOEMP']);
        $notafiscal->setCdtipooper($rowNotaFiscal['CDTIPOOPER']);
        $notafiscal->setCdserieentr($rowNotaFiscal['CDSERIEENTR']);
        $notafiscal->setIdstatus($rowNotaFiscal['IDSTATUS']);
        $notafiscal->setDtlancamennf($rowNotaFiscal['DTCONTRATOEMP']);
        $notafiscal->setCdoperactpg($rowNotaFiscal['CDOPERACTPG']);
        $notafiscal->setDtinclusao(DateUtil::getDataAtual());

        return $notafiscal;
    }

    /*public function insereNotaFiscalPagar(
        $nrorg, $cdfilial, $cdfiliorig, $nrlanctonf, $cdempresa, $cdinscesta, $cdinscmuni,
        $idtpijurnf, $nrinsjurnf, $cdforneced, $vrnotafisc, $nrnotafisc, $dtcontratoemp,
        $cdtipooper, $cdserieentr, $idstatus, $cdoperactpg
    ){

        $notafiscal = new Notafiscal();
        $notafiscal->setNrorg($nrorg);
        $notafiscal->setCdfilial($cdfilial);
        $notafiscal->setCdfilirece($cdfiliorig);
        $notafiscal->setNrlanctonf($nrlanctonf);
        $notafiscal->setCdempresa($cdempresa);
        $notafiscal->setCdinscesta($cdinscesta);
        $notafiscal->setCdinscmuni($cdinscmuni);
        $notafiscal->setIdtpijurnf($idtpijurnf);
        $notafiscal->setNrinsjurnf($nrinsjurnf);
        $notafiscal->setCdforneced($cdforneced);
        $notafiscal->setIddocfinanc('S');
        $notafiscal->setIddocfiscal('N');
        $notafiscal->setIdbloqueado('S');
        $notafiscal->setIdentrsaidop('E');
        $notafiscal->setIddoccontab('S');
        $notafiscal->setIdsistema('PAG');
        $notafiscal->setVrprodutos($vrnotafisc);
        $notafiscal->setVrnotafisc($vrnotafisc);
        $notafiscal->setNrnotafisc($nrnotafisc);
        $notafiscal->setDtemissao($dtcontratoemp);
        $notafiscal->setDtentrsaid($dtcontratoemp);
        $notafiscal->setCdtipooper($cdtipooper);
        $notafiscal->setCdserieentr($cdserieentr);
        $notafiscal->setIdstatus($idstatus);
        $notafiscal->setDtlancamennf($dtcontratoemp);
        $notafiscal->setCdoperactpg($cdoperactpg);
        $notafiscal->setDtinclusao(DateUtil::getDataAtual());

        return $notafiscal;
    }*/

    public function insereEmprestimoLeasing($rowEmpleasing){

        /** @var Empleasing $empleasing */
        $empleasing = new Empleasing();
        $empleasing->setCdfiliproc($rowEmpleasing['CDFILIPROC']);
        $empleasing->setNrsequencialemp($rowEmpleasing['NRSEQUENCIALEMP']);
        $empleasing->setCdfiliorigem($rowEmpleasing['CDFILIAL']);
        $empleasing->setCdforneced($rowEmpleasing['CDFORNECED']);
        $empleasing->setCdtpctpagar($rowEmpleasing['CDTPCTPAGAR']);
        $empleasing->setCdserieentr($rowEmpleasing['CDSERIEENTR']);
        $empleasing->setQtparcelaemp($rowEmpleasing['QTPARCELAEMP']);
        $empleasing->setDtprivencemp($rowEmpleasing['DTPRIVENCEMP']);
        $empleasing->setDtemprestimo($rowEmpleasing['DTEMPRESTIMO']);
        $empleasing->setNrdocumentoemp($rowEmpleasing['NRNOTAFISC']);
        $empleasing->setQtdiaprxvencemp($rowEmpleasing['QTDIAPRXVENCEMP']);
        $empleasing->setVrtotalemp($rowEmpleasing['VRTOTALEMP']);
        $empleasing->setVrliquidoemp($rowEmpleasing['VRTOTALEMP']);
        $empleasing->setCdtipooper($rowEmpleasing['CDTIPOOPER']);
        $empleasing->setIdtxjurosemp($rowEmpleasing['IDTXJUROSEMP']);
        $empleasing->setVrtxjurosemp($rowEmpleasing['VRTXJUROSEMP']);
        $empleasing->setDstxjurosemp($rowEmpleasing['DSTXJUROSEMP']);
        $empleasing->setVrtotalajustemp($rowEmpleasing['VRTOTALAJUSTEMP']);
        $empleasing->setCdajuctpag($rowEmpleasing['CDAJUCTPAG']);
        $empleasing->setDsajusteemp($rowEmpleasing['DSAJUSTEEMP']);
        $empleasing->setDtcontratoemp($rowEmpleasing['DTCONTRATOEMP']);
        $empleasing->setCdtpgarantiaemp($rowEmpleasing['CDTPGARANTIAEMP']);
        $empleasing->setCdtpbaixapag($rowEmpleasing['CDTPBAIXAPAG']);
        $empleasing->setIdtipoemp($rowEmpleasing['IDTIPOEMP']);
        $empleasing->setNrorg($rowEmpleasing['NRORG']);
        $empleasing->setDtinclusao(DateUtil::getDataAtual());

        return $empleasing;
    }

    /*public function insereEmprestimoLeasing($cdfiliproc, $prxnumero, $cdfilial, $cdforneced, $cdserieentr, $qtparcelaemp, $dtprivencemp,
                                          $dtemprestimo, $documento, $qtdiaprxvencemp, $valortotal, $cdtipooper, $idtxjurosemp,
                                          $vrtxjurosemp, $dstxjurosemp, $vrtotalajustemp, $cdajuctpag, $dsajusteemp, $dtcontratoemp,
                                          $cdtpgarantiaemp, $cdtpbaixapag, $idtipoemp, $cdtpctpagar, $nrorg
    ){


        $empleasing = new Empleasing();
        $empleasing->setCdfiliproc($cdfiliproc);
        $empleasing->setNrsequencialemp($prxnumero);
        $empleasing->setCdfiliorigem($cdfilial);
        $empleasing->setCdforneced($cdforneced);
        $empleasing->setCdtpctpagar($cdtpctpagar);
        $empleasing->setCdserieentr($cdserieentr);
        $empleasing->setQtparcelaemp($qtparcelaemp);
        $empleasing->setDtprivencemp($dtprivencemp);
        $empleasing->setDtemprestimo($dtemprestimo);
        $empleasing->setNrdocumentoemp($documento);
        $empleasing->setQtdiaprxvencemp($qtdiaprxvencemp);
        $empleasing->setVrtotalemp($valortotal);
        $empleasing->setVrliquidoemp($valortotal);
        $empleasing->setCdtipooper($cdtipooper);
        $empleasing->setIdtxjurosemp($idtxjurosemp);
        $empleasing->setVrtxjurosemp($vrtxjurosemp);
        $empleasing->setDstxjurosemp($dstxjurosemp);
        $empleasing->setVrtotalajustemp($vrtotalajustemp);
        $empleasing->setCdajuctpag($cdajuctpag);
        $empleasing->setDsajusteemp($dsajusteemp);
        $empleasing->setDtcontratoemp($dtcontratoemp);
        $empleasing->setCdtpgarantiaemp($cdtpgarantiaemp);
        $empleasing->setCdtpbaixapag($cdtpbaixapag);
        $empleasing->setIdtipoemp($idtipoemp);
        $empleasing->setNrorg($nrorg);
        $empleasing->setDtinclusao(DateUtil::getDataAtual());

        return $empleasing;
    }*/

    public function insereBoletoPagar($rowBoleto){
        /** @var Boletpagar $boletpagar */
        $boletpagar = new Boletpagar();
        $boletpagar->setNrorg($rowBoleto['NRORG']);
        $boletpagar->setCdfilial($rowBoleto['CDFILIAL']);
        $boletpagar->setNrlanbolpag($rowBoleto['NRLANBOLPAG']);
        $boletpagar->setCdforneced($rowBoleto['CDFORNECED']);
        $boletpagar->setCdempresa($rowBoleto['CDEMPRESA']);
        $boletpagar->setVrbolpag($rowBoleto['VRBOLPAG']);
        $boletpagar->setVrfinalbpag($rowBoleto['VRFINALBPAG']);
        $boletpagar->setDtvenbolpag($rowBoleto['DTVENBOLPAG']);
        $boletpagar->setCdbancbolp($rowBoleto['CDBANCBOLP']);
        $boletpagar->setCdagenbolp($rowBoleto['CDAGENBOLP']);
        $boletpagar->setCdccorbolp($rowBoleto['CDCCORBOLP']);
        $boletpagar->setIdhabibpag($rowBoleto['IDHABIBPAG']);
        $boletpagar->setCdtpbaixapag($rowBoleto['CDTPBAIXAPAG']);
        $boletpagar->setIdbpagreal($rowBoleto['IDBPAGREAL']);
        $boletpagar->setNrparcbolpag($rowBoleto['NRPARCBOLPAG']);
        $boletpagar->setCdoperinclusao($rowBoleto['CDOPERINCLUSAO']);
        $boletpagar->setDtinclusao(DateUtil::getDataAtual());

        return $boletpagar;
    }


    /*public function insereBoletoPagar(
        $nrorg, $cdfilial, $nrlanbolpag, $cdforneced, $cdempresa, $vrbolpag, $vrfinalbpag,
        $dtvenbolpag, $vrmultabpag, $cdbancbolp, $cdagenbolp,
        $cdccorbolp, $idhabibpag, $cdtpbaixapag, $idbpagreal, $nrparcbolpag
    ){

        $boletpagar = new Boletpagar();
        $boletpagar->setNrorg($nrorg);
        $boletpagar->setCdfilial($cdfilial);
        $boletpagar->setNrlanbolpag($nrlanbolpag);
        $boletpagar->setCdforneced($cdforneced);
        $boletpagar->setCdempresa($cdempresa);
        $boletpagar->setVrbolpag($vrbolpag);
        $boletpagar->setVrfinalbpag($vrfinalbpag);
        $boletpagar->setDtvenbolpag($dtvenbolpag);
        $boletpagar->setCdbancbolp($cdbancbolp);
        $boletpagar->setCdagenbolp($cdagenbolp);
        $boletpagar->setCdccorbolp($cdccorbolp);
        $boletpagar->setIdhabibpag($idhabibpag);
        $boletpagar->setCdtpbaixapag($cdtpbaixapag);
        $boletpagar->setIdbpagreal($idbpagreal);
        $boletpagar->setNrparcbolpag($nrparcbolpag);
        $boletpagar->setDtinclusao(DateUtil::getDataAtual());

        return $boletpagar;
    }*/

    public function getParamgeral(){
        $parans = array();
        $paramgeral = $this->entityManager->getRepository(Paramgeral::class)->findOneBy($parans);
        return $paramgeral;
    }

    public function getAjusteboletoPagar($parans){
        $ajbolpag = $this->entityManager->getRepository(Ajbolpag::class)->findOneBy($parans);
        return $ajbolpag;
    }

     public function getAjustesboletoPagar($parans){
        $ajbolpag = $this->entityManager->getRepository(Ajbolpag::class)->findBy($parans);
        return $ajbolpag;
    }

    public function insereAjusteBoletPagar($rowAjusteBoleto){
        /** @var Ajbolpag $ajbolpag */
        $ajbolpag = new Ajbolpag();
        $ajbolpag->setNrorg($rowAjusteBoleto['NRORG']);
        $ajbolpag->setCdfilial($rowAjusteBoleto['CDFILIPROC']);
        $ajbolpag->setNrlanbolpag($rowAjusteBoleto['NRLANBOLPAG']);
        $ajbolpag->setCdajuctpag($rowAjusteBoleto['CDAJUCTPAG']);
        $ajbolpag->setIdorigajbpag($rowAjusteBoleto['IDORIGAJBPAG']);
        $ajbolpag->setIdtpajbolpag($rowAjusteBoleto['IDTPAJBOLPAG']);
        $ajbolpag->setVrajbolpag($rowAjusteBoleto['VRAJBOLPAG']);
        $ajbolpag->setDtinclusao(DateUtil::getDataAtual());

        return $ajbolpag;
    }

    public function getFornecedor($nrorg, $cdforneced){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdforneced'] = $cdforneced;
        $fornecedor = $this->entityManager->getRepository(Fornecedor::class)->findOneBy($parans);
        return $fornecedor;
    }

    public function getGeralpag(){
        $parans = array();
        $geralPag = $this->entityManager->getRepository(GeralPag::class)->findOneBy($parans);
        return $geralPag;
    }

    public function getOpergrupop($operador, $grupoContaPagar){
        $parans = array();
        $parans['cdoperador'] = $operador;
        $parans['cdgrupoper'] = $grupoContaPagar;
        $opergrupop = $this->entityManager->getRepository(Opergrupop::class)->findOneBy($parans);
        return $opergrupop;
    }

    //ENTIDADES DE CONTABILIZAÇÃO
    public function getLanccont($nrorg, $cdempresa, $nrlanccont){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdempresa'] = $cdempresa;
        $parans['nrlanccont'] = $nrlanccont;
        $lanccont = $this->entityManager->getRepository(Lanccont::class)->findOneBy($parans);
        return $lanccont;
    }

    public function getContopectbl($nrorg, $cdempresa){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdempresa'] = $cdempresa;
        $contopectbl = $this->entityManager->getRepository(Contopectbl::class)->findOneBy($parans);
        return $contopectbl;
    }

    public function getMovbancario($nrorg, $nrmovbanc, $cdreducont){
        try {
            $params = array();
            $params['nrorg'] = $nrorg;
            $params['nrmovbanc'] = $nrmovbanc;
            $params['cdreducont'] = $cdreducont;
            $movbancario = $this->entityManager->getRepository(Movbancario::class)->findOneBy($params);
            return $movbancario;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getMovdebbanc($nrorg, $nrmovbanc, $cdreducont){
        try {
            $params = array();
            $params['nrorg'] = $nrorg;
            $params['nrmovbanc'] = $nrmovbanc;
            $params['cdreducont'] = $cdreducont;
            $movdebbanc = $this->entityManager->getRepository(Movdebbanc::class)->findOneBy($params);
            return $movdebbanc;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getMovcredbanc($nrorg, $nrmovbanc, $cdreducont){
        try {
            $params = array();
            $params['nrorg'] = $nrorg;
            $params['nrmovbanc'] = $nrmovbanc;
            $params['cdreducont'] = $cdreducont;
            $movcredbanc = $this->entityManager->getRepository(Movcredbanc::class)->findOneBy($params);
            return $movcredbanc;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function excluiLancamentoContabilEstorno($cdempresa, $nrlanccont, $nrorg){
        $delete = <<<SQL
            DELETE LANCCONT
             WHERE (CDEMPRESA  = :CDEMPRESA)  AND
                   (NRLANCCONT = :NRLANCCONT) AND
                   (NRORG = :NRORG)           AND
                   (IDLANCINTE <> 'L')
SQL;

        $params = array(
            'CDEMPRESA' => $cdempresa,
            'NRLANCCONT' => $nrlanccont,
            'NRORG' => $nrorg
        );
        $std = $this->entityManager->getConnection()->prepare($delete);
        $std->execute($params);
    }

    public function getContaPagar($parans){
        $contapagar = $this->entityManager->getRepository(Contapagar::class)->findOneBy($parans);
        return $contapagar;
    }

    public function getContasPagar($parans){
        $contapagar = $this->entityManager->getRepository(Contapagar::class)->findBy($parans);
        return $contapagar;
    }

    public function getContaCorrenteFornecedor($nrorg, $cdforneced){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdforneced'] = $cdforneced;
        $ccorforn = $this->entityManager->getRepository(Ccorforn::class)->findOneBy($parans);
        return $ccorforn;
    }

    public function getEmpleasing($nrorg, $nrsequencialemp, $cdfiliproc){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['nrsequencialemp'] = $nrsequencialemp;
        $parans['cdfiliproc'] = $cdfiliproc;
        $empleasing = $this->entityManager->getRepository(Empleasing::class)->findOneBy($parans);
        return $empleasing;
    }

    public function getVencimentoContaPagar($nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanctonf'] = $nrlanctonf;
        $parans['nrseqvenpag'] = $nrseqvenpag;
        $parans['nrparcelapag'] = $nrparcelapag;
        $contapagar = $this->entityManager->getRepository(Contapagar::class)->findOneBy($parans);
        return $contapagar;
    }

     public function getAjusteContaPagar($nrorg, $cdajuctpag, $dtajustepag, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdajuctpag'] = $cdajuctpag;
        $parans['dtajustepag'] = $dtajustepag;
        $parans['cdfilial'] = $cdfilial;
        $parans['nrlanctonf'] = $nrlanctonf;
        $parans['nrseqvenpag'] = $nrseqvenpag;
        $parans['nrparcelapag'] = $nrparcelapag;
        $ajctpagar = $this->entityManager->getRepository(Ajctpagar::class)->findOneBy($parans);
        return $ajctpagar;
    }

    public function getContasPorBoleto($nrorg, $cdfilibolpag, $nrlanbolpag){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdfilibpag'] = $cdfilibolpag;
        $parans['nrlanbolpag'] = $nrlanbolpag;
        $contapagar = $this->entityManager->getRepository(Contapagar::class)->findOneBy($parans);
        return $contapagar;
    }

    public function getNotaFiscal($parans){
        $notaFiscal = $this->entityManager->getRepository(Notafiscal::class)->findOneBy($parans);
        return $notaFiscal;
    }

    public function verificaDocumento($nrorg, $cdforneced, $cdserieentr, $nrnotafisc){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdforneced'] = $cdforneced;
        $parans['cdserieentr'] = $cdserieentr;
        $parans['nrnotafisc'] = $nrnotafisc;
        $notaFiscal = $this->entityManager->getRepository(Notafiscal::class)->findOneBy($parans);
        return $notaFiscal;
    }

    public function getBoletPagar($parans){
        $boletPagar = $this->entityManager->getRepository(Boletpagar::class)->findOneBy($parans);
        return $boletPagar;
    }

    public function getDadosLanc($nrmovbanc, $cdreducont, $debcred)
    {
        $params = array();
        $params['NRMOVBANC'] = $nrmovbanc;
        $params['CDREDUCONT'] = $cdreducont;
        $params['DEBCRED'] = $debcred;
        $sql = "SELECT LANC.CDEMPRESA,
                       LANC.CDFILIAL,
                       LANC.CDCLASSFINA,
                       LANC.DTMOVFLUXO,
                       LANC.IDMOVFLUXO
                  FROM (SELECT 'D' AS DEBCRED,
                               CDEMPRESA,
                               CDFILIAL,
                               CDCLASSFINA,
                               DTMOVFLUXO,
                               IDMOVFLUXO
                          FROM MOVDEBBANC
                         WHERE (NRMOVBANC   = :NRMOVBANC ) AND
                               (CDREDUCONT  = :CDREDUCONT)
                 UNION
                        SELECT 'C' AS DEBCRED,
                               CDEMPRESA,
                               CDFILIAL,
                               CDCLASSFINA,
                               DTMOVFLUXO,
                               IDMOVFLUXO
                          FROM MOVCREDBANC
                         WHERE (NRMOVICRED = :NRMOVBANC ) AND
                               (CDREDUCONT = :CDREDUCONT)) LANC
                 WHERE LANC.DEBCRED = :DEBCRED";
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getRecalculaRateio($nrorg, $cdempresa, $dtmovbanc){
        $sql = <<<SQL
        SELECT CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG, CDCENTCUST, CDFIRATCTPAG,
               VRRATCCCTPAG, NMFILIAL, VRATUAPAG, NMCENTCUST, VRPERATEIO
          FROM (SELECT RP.CDFILIAL  , RP.NRLANCTONF  , RP.NRSEQVENPAG , RP.NRPARCELAPAG, RP.CDCENTCUST,
                RP.CDFIRATCTPAG, RP.VRRATCCCTPAG, FI.NMFILIAL, CP.VRATUAPAG,  CC.NMCENTCUST,
                CONVERT(NUMERIC,(CASE CP.VRATUAPAG WHEN 0 THEN 0 ELSE ROUND((RP.VRRATCCCTPAG * 100)/CP.VRATUAPAG, 2) END)) VRPERATEIO
                  FROM RATCTPAGAR RP, FILIAL FI, CENTCUST CC, CONTAPAGAR CP
                 WHERE (RP.CDFILIAL     = :CDFILIAL      )
                   AND (RP.NRLANCTONF   = :NRLANCTONF    )
                   AND (RP.NRSEQVENPAG  = :NRSEQVENPAG   )
                   AND   (RP.NRPARCELAPAG = ISNULL(:NRPARCELAPAG, RP.NRPARCELAPAG))
                   AND   (FI.CDFILIAL     = RP.CDFIRATCTPAG)
                   AND   (CC.CDCENTCUST   = RP.CDCENTCUST  )
                   AND   (CP.CDFILIAL     = RP.CDFILIAL    )
                   AND   (CP.NRLANCTONF   = RP.NRLANCTONF  )
                   AND   (CP.NRSEQVENPAG  = RP.NRSEQVENPAG )
                   AND   (CP.NRPARCELAPAG = RP.NRPARCELAPAG) ) A
         ORDER BY CDFIRATCTPAG, CDCENTCUST, VRRATCCCTPAG
SQL;
        $params = array(
            'CDFILIAL' => $cdempresa,
            'NRLANCTONF' => $dtmovbanc,
            'NRSEQVENPAG' => $dtmovbanc,
            'NRPARCELAPAG' => $dtmovbanc
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getAjustes($cdfilial, $nrlanbolpag){
        $sql = <<<SQL
        SELECT AB.CDFILIAL, AB.NRLANBOLPAG, AB.CDAJUCTPAG, AB.VRAJBOLPAG,
               AB.IDORIGAJBPAG, TA.IDAJUCTPAG, TA.DSAJUCTPAG
          FROM AJBOLPAG AB, TIPOAJPAGAR TA
         WHERE AB.CDFILIAL = :CDFILIAL
           AND AB.NRLANBOLPAG = :NRLANBOLPAG
           AND TA.CDAJUCTPAG = AB.CDAJUCTPAG
           AND (AB.IDORIGAJBPAG <> '4')
         ORDER BY AB.CDAJUCTPAG
SQL;

        $params = array(
            'CDFILIAL' => $cdfilial,
            'NRLANBOLPAG' => $nrlanbolpag
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function verificaNotaCadastrada($cdforneced, $serie, $nrnotafisc, $nrorg){
        $sql = <<<SQL
        SELECT NRNOTAFISC
          FROM NOTAFISCAL
         WHERE (CDFORNECED            = :CDFORNECED) AND
               (CDSERIEENTR           = :SERIE     ) AND
               (LPAD(NRNOTAFISC,10,0) = :NRNOTAFISC) AND
               (NRORG                 = :NRORG)
SQL;

        $params = array(
            'CDFORNECED' => $cdforneced,
            'SERIE' => $serie,
            'NRNOTAFISC' => $nrnotafisc,
            'NRORG' => $nrorg
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchColumn();
    }

    public function getRatctpagar($parans){
        $ratctpagar = $this->entityManager->getRepository(Ratctpagar::class)->findOneBy($parans);
        return $ratctpagar;
    }


    /////////gera rateio/////////

    /*public function getRatctpagar($nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag){
        $parans = array();
        $parans['nrorg'] = $nrorg;
        $parans['cdtpctpagar'] = $cdtpctpagar;
        $rattpctp = $this->entityManager->getRepository(Rattpctp::class)->findOneBy($parans);
        return $rattpctp;
    }*/

    public function getNovoCodigoEmprestimo($nrorg, $cdfiliproc){
        $sql = <<<SQL
           SELECT NVL(MAX(NRSEQUENCIALEMP+1),1) AS PRXNUMERO
             FROM EMPLEASING
            WHERE CDFILIPROC = :CDFILIPROC
              AND NRORG = :NRORG
SQL;
        $params = array(
            'NRORG' => $nrorg,
            'CDFILIPROC' => $cdfiliproc
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchColumn();
    }

    public function getContas($cdreducont){
        $sql = <<<SQL
            SELECT C.CDREDUCONT, C.CDBANCO, C.CDAGENCIA,
                   C.CDCONTCTBL, C.CDCONTCORR, C.DSCONTCORR,
                   C.IDTIPOCCORR, B.CDPICTCONT, C.CDEMPRESA,
                   E.NMEMPRESA
              FROM EMPRESA E, BANCO B, CONTCORR C
             WHERE (C.CDREDUCONT = NVL(:CDREDUCONT, C.CDREDUCONT)) AND
                   (C.CDBANCO    = B.CDBANCO)                      AND
                   (E.CDEMPRESA  = C.CDEMPRESA)
             ORDER BY
                C.CDREDUCONT
SQL;
        $params = array(
            'CDREDUCONT' => $cdreducont
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
    }

    public function getMovimentoBancario($row){
        $sql = <<<SQL
           SELECT DTMOVBANC
             FROM MOVBANCARIO
            WHERE (NRORG =      :NRORG)                    AND
                  (CDREDUCONT = :CDREDUCONT)               AND
                  (DTMOVBANC  = :DTMOVBANC)                AND
                  (NRDOCMBANC = :NRDOCMBANC)               AND
                  (VRMOVBANC  = :VRMOVBANC)                AND
                  (UPPER(DSHISMBANC) = UPPER(:DSHISMBANC))
            ORDER BY DTMOVBANC
SQL;
        $params = array(
            'NRORG'      => $row['NRORG'],
            'CDREDUCONT' => $row['CDREDUCONT'],
            'DTMOVBANC'  => $row['DATAMOVIMENTO'],
            'NRDOCMBANC' => $row['NRDOCMBANC'],
            'VRMOVBANC'  => $row['VRMOVBANC'],
            'DSHISMBANC' => $row['DSHISMBANC']
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchColumn();
    }

    public function getProxCodEmprestimo($nrorg, $cdforneced, $cdserieentr, $nrnotafisc){
        $sql = <<<SQL
           SELECT LPAD(MAX(C.NRSEQUENCIALEMP), 10, '0') AS NRSEQUENCIALEMP
             FROM NOTAFISCAL N, CONTAPAGAR C
            WHERE (N.CDFILIAL   = C.CDFILIAL  )  AND
                  (N.NRLANCTONF = C.NRLANCTONF)  AND
                  (N.CDEMPRESA  = C.CDEMPRESA )  AND
                  (N.CDFORNECED   = :CDFORNECED )  AND
                  (N.CDSERIEENTR  = :CDSERIEENTR)  AND
                  (C.NRORG        = :NRORG      )  AND
                  (N.NRNOTAFISC   = :NRNOTAFISC )
SQL;
        $params = array(
            'NRORG' => $nrorg,
            'CDFORNECED' => $cdforneced,
            'CDSERIEENTR' => $cdserieentr,
            'NRNOTAFISC' => $nrnotafisc
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchColumn();
    }

    public function getCentroCusto($nrorg, $cdfilial){
        $sql = <<<SQL
            SELECT NVL(E.CDCENTCUST, F.CDCENTCUST) AS CDCENTCUST
              FROM FILIAL F, EMPRESA E
             WHERE F.CDEMPRESA = E.CDEMPRESA AND
                   F.NRORG     = E.NRORG     AND
                   F.NRORG  = :NRORG     AND
                   F.CDFILIAL  = :CDFILIAL
SQL;
        $params = array(
            'CDFILIAL' => $cdfilial,
            'NRORG'    => $nrorg
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchColumn();
    }

    public function getContaContabil($cdempresa, $cdfilial, $nrinsjurforn){
        $sql = <<<SQL
            SELECT NVL(NVL(NVL(F.CDCONTCTBL, L.CDCONFORNFI), E.CDCONFORNEM), P.CDCONTFORN) CDCONTCTBL
              FROM FORNECEDOR F, PARAMFILIAL L, PARAMEMPRESA E, PARAMCTBL P
             WHERE E.CDEMPRESA    = :CDEMPRESA AND
                   L.CDFILIAL     = :CDFILIAL AND
                   F.NRINSJURFORN = :NRINSJURFORN
SQL;
        $params = array(
            'CDEMPRESA' => $cdempresa,
            'CDFILIAL'    => $cdfilial,
            'NRINSJURFORN'    => $nrinsjurforn
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchColumn();
    }

    public function getHistoricoTipoContaPagar($nrorg, $cdtipopagar){
        $sql = <<<SQL
            SELECT T.CDHISTPADR, H.DSHISTPADR, T.DSTPCTPAGAR AS DSTIPOCONTA
              FROM TIPOCTPAGAR T, HISTPADR H
             WHERE T.CDTPCTPAGAR = :CDTIPOPAGAR AND
                   T.NRORG = :NRORG             AND
                   T.CDHISTPADR = H.CDHISTPADR  AND
                   T.NRORG = H.NRORG
SQL;
        $params = array(
            'NRORG' => $nrorg,
            'CDTIPOPAGAR' => $cdtipopagar
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetch();
    }

    public function getHistoricoIntegracao($nrorg, $cdtipopagar){
        $sql = <<<SQL

SQL;
        $params = array(
            '' => $nrorg,
            '' => $cdtipopagar
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
    }

    public function getAjustePagar($cdfilial, $nrlanctonf, $nrseqvenpag, $tnrseqvenpag, $nrparcelapag, $tnrparcelapag, $dtajustepag, $tdtajustepag, $cdajuctpag, $tcdajuctpag){
        $sql = <<<SQL
            SELECT A.CDFILIAL   , A.NRLANCTONF  , A.NRSEQVENPAG , A.NRPARCELAPAG,
                   A.DTAJUSTEPAG, A.CDAJUCTPAG  , T.IDAJUCTPAG  , T.DSAJUCTPAG  ,
                   A.DSAJUSTEPAG, A.VRAJUSTEPAG , A.CDECTBAJPAG , A.NRLCTBAJPAG ,
                   A.CDCLASSFINA, A.CDEMMFAJCNTP, A.CDFIMFAJCNTP, A.DTMOVFLUXO  ,
                   A.IDMOVFLUXO, NF.CDFILIRECE AS CDFILIORIG
              FROM AJCTPAGAR A, TIPOAJPAGAR T, NOTAFISCAL NF
             WHERE (A.CDFILIAL     = :CDFILIAL    )
               AND (A.NRLANCTONF   = :NRLANCTONF  )
               AND (A.NRSEQVENPAG  = :NRSEQVENPAG  or :TNRSEQVENPAG  = 'T')
               AND (A.NRPARCELAPAG = :NRPARCELAPAG or :TNRPARCELAPAG = 'T')
               AND (A.DTAJUSTEPAG  = :DTAJUSTEPAG  or :TDTAJUSTEPAG  = 'T')
               AND (A.CDAJUCTPAG   = :CDAJUCTPAG   or :TCDAJUCTPAG   = 'T')
               AND (A.CDAJUCTPAG   = T.CDAJUCTPAG)
               AND (NF.CDFILIAL    = A.CDFILIAL)
               AND (NF.NRLANCTONF  = A.NRLANCTONF)
             ORDER BY A.CDFILIAL, A.NRLANCTONF, A.CDAJUCTPAG
SQL;
        $params = array(
            'cdfilial'      => $cdfilial,
            'nrlanctonf'    => $nrlanctonf,
            'nrseqvenpag'   => $nrseqvenpag,
            'tnrseqvenpag'  => $tnrseqvenpag,
            'nrparcelapag'  => $nrparcelapag,
            'tnrparcelapag' => $tnrparcelapag,
            'dtajustepag'   => $dtajustepag,
            'tdtajustepag'  => $tdtajustepag,
            'cdajuctpag'    => $cdajuctpag,
            'tcdajuctpag'   => $tcdajuctpag,
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
    }
}
?>